"use strict";
var path = require("path");
var _1 = require("./");
var lodash_1 = require("lodash");
var readFile = require("fs-readfile-promise");
var recursive = require("recursive-readdir");
var unixify = require("unixify");
function directory(target) {
    if (typeof target !== 'string') {
        return Promise.reject('Target must be a string');
    }
    var targetNodeModules = path.normalize(path.join(target, 'node_modules'));
    return new Promise(function (resolve, reject) {
        var files = recursive(target, [ignore.bind(null, targetNodeModules)], function (err, files) {
            if (err)
                return reject(err);
            resolve(files);
        });
    }).then(function (files) {
        return Promise.all(files.map(function (file) {
            file = path.relative(target, file);
            file = unixify(file);
            return _1.node("./" + file, { baseDir: target });
        }))
            .then(function (result) {
            return lodash_1.flatten(result);
        });
    });
}
exports.directory = directory;
function ignore(targetNodeModules, file, stats) {
    if (lodash_1.startsWith(file, targetNodeModules))
        return true;
    if (stats.isDirectory())
        return false;
    if (lodash_1.endsWith(path.extname(file), ".ts"))
        return false;
    return true;
}
//# sourceMappingURL=directory.js.map